// mouse ATtiny26L
// by takuya matsubara
// http://nicotak.com

#include <avr/io.h>
//#include <avr/interrupt.h>
//#include <avr/signal.h>
//#include <avr/sleep.h>
#include "sio.h"

#ifndef F_CPU
#define   F_CPU   8000000    //CPUNbNg 8MHz
#endif

#define  PRESCALE   8        //vXP[l
#define  PRESCALECR 2        //vXP[ݒl
//1=div1/2=div8/3=div64/4=div256/5=div1024
#define TCNT_250USEC   (0x100-((F_CPU/PRESCALE)/(1000000/250)))
#define TCNT_60USEC    (0x100-((F_CPU/PRESCALE)/(1000000/60)))
#define TCNT_45USEC    (0x100-((F_CPU/PRESCALE)/(1000000/45)))
#define TCNT_40USEC    (0x100-((F_CPU/PRESCALE)/(1000000/40)))
#define TCNT_30USEC    (0x100-((F_CPU/PRESCALE)/(1000000/30)))
#define TCNT_20USEC    (0x100-((F_CPU/PRESCALE)/(1000000/20)))
#define TCNT_15USEC    (0x100-((F_CPU/PRESCALE)/(1000000/15)))
#define TCNT_5USEC     (0x100-((F_CPU/PRESCALE)/(1000000/5)))
#define TCNT_2USEC     (0x100-((F_CPU/PRESCALE)/(1000000/2)))

#define  PRESCALE2   1024        //vXP[l
#define  PRESCALECR2 5        //vXP[ݒl
#define TCNT_10MSEC    (0x100-((F_CPU/PRESCALE2)/(1000/10)))

#define PS2_DATAPIN  PINB
#define PS2_DATAPORT PORTB
#define PS2_DATADDR  DDRB
#define PS2_DATABIT  (1<<3)	//bit mask

#define PS2_CLKPIN   PINB
#define PS2_CLKPORT  PORTB
#define PS2_CLKDDR   DDRB
#define PS2_CLKBIT   (1<<6)	//bit mask

#define PS2CLK_HIGH  (PS2_CLKPIN & PS2_CLKBIT)
#define PS2DATA_HIGH (PS2_DATAPIN & PS2_DATABIT)
#define PS2CLK_LOW (PS2CLK_HIGH==0)
#define PS2DATA_LOW (PS2DATA_HIGH==0)

#define USEPULLUP 0

char rcnta=0;	//MJE^
char rcntb=0;
#define RECVBUFMAX 8
unsigned char recvbuf[RECVBUFMAX];

char scnta=0;	//MJE^
char scntb=0;
#define SENDBUFMAX 8
unsigned char sendbuf[SENDBUFMAX];

char parity;
unsigned char bitmask;
unsigned char tempdata;

// 10i2 VAM
void sio_txhex(unsigned char x)
{
    unsigned char ch;
    char shift=4;
	
	while(1){
		ch = (x >> shift) & 0xf;
		if(ch < 10){
			sio_tx('0'+ch);
		}else{
			sio_tx(('A'-10)+ch);
		}
		if(shift==0)break;
		shift -= 4;
	}
}

// 10i4 VAM
void sio_txdec(int x)
{
    unsigned char temp;
	int ketaval=1000;

	if(x < 0){
		x = -x;
		sio_tx('-');
	}

    while (ketaval != 0) {
        temp = x / ketaval;
		if(temp > 9) temp=9;
		sio_tx('0'+temp);
		x -= (ketaval*temp);
		ketaval /= 10;
    }
}
//------------------------------
//void wait_10msec(void)
//{
//	// 10msec wait(sampilng rate 100/sec)
//	TCCR0= PRESCALECR2;    // TCCR0 ^C}0[h 
//   	TCNT0 = TCNT_10MSEC;   // ^C}0̏lݒ   
//    TIFR |= (1 << TOV0);    // ^C}0I[o[t[tONA
//	while((TIFR & (1 << TOV0))==0){
//		if(PS2CLK_LOW)break;
//	}
//}

//--------------------------------------------
void timer_wait(unsigned char tcnt)
{
    TCCR0= PRESCALECR;    // TCCR0 ^C}0[h 
    TCNT0 = tcnt;   // ^C}0̏lݒ   
    TIFR |= (1 << TOV0);    // ^C}0I[o[t[tONA
//    TIMSK |= (1 << TOIE0);  // ^C}0I[o[t[荞݋

	while((TIFR & (1 << TOV0))==0);
}

//--------------------------------------------
void ps2_clk_high(void)
{
#if USEPULLUP
	PS2_CLKPORT |= PS2_CLKBIT;//pullup(vAbvĂȂsv)
#endif
	PS2_CLKDDR &= ~PS2_CLKBIT;	//nCCs[_X
}

void ps2_clk_low(void)
{
#if USEPULLUP
	PS2_CLKPORT &= ~PS2_CLKBIT;
#endif
	PS2_CLKDDR |= PS2_CLKBIT;
}

void ps2_data_high(void)
{
#if USEPULLUP
	PS2_DATAPORT |= PS2_DATABIT;//pullup(vAbvĂȂsv)
#endif
	PS2_DATADDR &= ~PS2_DATABIT;	//nCCs[_X
}

void ps2_data_low(void)
{
#if USEPULLUP
	PS2_DATAPORT &= ~PS2_DATABIT;	//low
#endif
	PS2_DATADDR |= PS2_DATABIT;
}

//-----------------------------------
void ps2_sendclk(void)
{
	timer_wait(TCNT_20USEC);
   	ps2_clk_low();
	timer_wait(TCNT_40USEC);
    ps2_clk_high();
	timer_wait(TCNT_20USEC);
}

unsigned char mouse_recvbyte(void)
{
	unsigned char tempdata;

	if(rcnta == rcntb)return(0);

	tempdata = recvbuf[(int)rcntb++];
	rcntb &= (RECVBUFMAX-1);

	return(tempdata);
}

//---------------------------------
void mouse_recvctrl(void)
{
	unsigned int usec=0;

		//̎_CLK/DATA̎哱̓zXg
    if(PS2CLK_HIGH)return;	//CLK L҂

		//CLK60usecȏL / DATA=H

    		//Start bit
	while(1){	//ԍDATA LɂȂ
		if(PS2DATA_LOW)	break;
    	if(PS2CLK_HIGH){
//			sio_txstr("!6");
			return;//error
		}
		timer_wait(TCNT_5USEC);
		usec +=5;
//		if(usec > 15000){
//			sio_txstr("!5");
//			return(0);//error
//		}
	}
	if(usec < 50){
		sio_txstr("!1");	//debug
		return;	//
	}
    while(1){		//CLK H҂
    	if(PS2CLK_HIGH)	break;
		if(PS2DATA_HIGH){
			sio_txstr("!2");	//debug
			return;//error
		}
		timer_wait(TCNT_5USEC);
		usec +=5;
//		if(usec > 15000){
//			sio_txstr("!4");	//debug
//			return(0);//error
//		}
	}
	if(usec < 100){
		sio_txstr("!3");	//debug
		return;//error
	}
		//̎_CLK̎哱̓}EX DATA̓zXg
	timer_wait(TCNT_60USEC);
	//ʂ8bitM
	bitmask=1;
	parity=0;
	tempdata=0;
    while(bitmask) {
		ps2_sendclk();
        if(PS2DATA_HIGH) {	//
			tempdata |= bitmask;
            parity++;
        }
        bitmask <<= 1;
    }
	ps2_sendclk();
    if(PS2DATA_HIGH) {	// odd parity bit
       parity++;
    }
	if((parity & 1)==0){
		sio_txstr("!P");
		return;//error
		//ȂpeBG[
	}

	ps2_sendclk();		// stop bit
    if(PS2DATA_LOW) {	//
		sio_txstr("!S");
		return;		//error
	}

   	ps2_data_low();    // ack
	ps2_sendclk();
   	ps2_data_high();

	recvbuf[(int)rcnta++] = tempdata;
	rcnta &= (RECVBUFMAX-1);
}


void mouse_ctrl(void)
{
#define BYTETIMMING 1000
	unsigned int usec=0;

	mouse_recvctrl();

	if(scnta == scntb)return;

		//CLK50usecȏH
	while(1){
    	if(PS2CLK_LOW){	//MɃzXgMꍇ
			mouse_recvctrl();
			return;//error
		}
    	if(PS2DATA_LOW)	return;//error
		timer_wait(TCNT_2USEC);
		usec +=2;
		if(usec >= BYTETIMMING)break;//኱
	}

	tempdata = sendbuf[(int)scntb++];
	scntb &= (SENDBUFMAX-1);
//	sio_tx('>');		//debug
//	sio_txhex(data);	//debug

    ps2_data_low();		//Start bit
	ps2_sendclk();

	//ʂ8bitM
	bitmask=1;
	parity=0;
    while(bitmask) {
        if(tempdata & bitmask) {	//
            ps2_data_high();
            parity++;
        } else {
            ps2_data_low();
        }
        bitmask <<= 1;
		ps2_sendclk();
    }

    if(parity & 1) {	// odd parity bit
        ps2_data_low();
    } else {
        ps2_data_high();
    }
	ps2_sendclk();

    ps2_data_high();		// stop bit
	ps2_sendclk();

}

unsigned char mouse_recvbyte_wait(void)
{
	unsigned char data;

	while(1){
		mouse_ctrl();
		data = mouse_recvbyte();
		if(data != 0)
			return(data);
	}
}


//-----------------------------------------
void mouse_sendbyte(unsigned char data)
{
	sendbuf[(int)scnta++] = data;
	scnta &= (SENDBUFMAX-1);
}

//-----------------------------------------
void mouse_sendbyte_wait(unsigned char data)
{
	mouse_sendbyte(data);

	while(1){
		mouse_ctrl();
		if(scnta == scntb)return;
	}
}


//-----------------------------------

void waitloop(unsigned int i)
{
	while(i--);
}



//---------------------------
void ad_init(int idtmp)
{
	ADCSR = (1<<ADEN)| 6;
	ADMUX = idtmp;	// `lݒ
}

// ------------------------A/D
int ad_get(void)
{
	ADCSR |= (1<<ADIF);
	ADCSR |= (1<<ADSC);	//AD start
	while((ADCSR & (1<<ADIF))==0){
	}

	return(ADCW);	// A/DJEgl(0-0x3ff)
}



#define BTN_PORT PORTA
#define BTN_PIN  PINA
#define BTN_DDR  DDRA
#define BTN_BIT (1<<2)


int main(void)
{
	unsigned char cmd;
	unsigned char button;
	char sample=0;
	char valx;
	char valy;
	char valx_zero=0;
	char valy_zero=0;
	char valx_bak=0;
	char valy_bak=0;
	unsigned char err=0;
	unsigned char button_bak=0;

	#define BITSHIFT 7

	PS2_DATAPORT &= ~PS2_DATABIT;
	PS2_CLKPORT &= ~PS2_CLKBIT;
	ps2_data_high();
	ps2_clk_high();
	sio_init();

	//	sei();	//荞݋
//	wait_10msec();
	sio_tx('*');

	BTN_PORT |= BTN_BIT; 	// init button(pullup)
	BTN_DDR  &= ~BTN_BIT; 

	while(1){
		if(sample > 0){	//data report 
			timer_wait(TCNT_60USEC);
			sample--;
			if(sample==0){
				sample=4*10;//10msec

				ad_init(0);
				valx = ad_get() >> BITSHIFT;

				ad_init(1);
				valy = ad_get() >> BITSHIFT;

				if(valx_zero==0){
					valx_zero = valx;	//zero position
					valy_zero = valy;	
				}
				valx -= valx_zero;
				valy -= valy_zero;

				button=8;				
				//bit0:left button
				//bit1:right button
				//bit2:mid button
				//bit3:1
				//bit4:x 0=right / 1=left
				//bit5:y 0=up / 1=down
				if((BTN_PIN & BTN_BIT)==0)	button |= 1;	// BUTTON ON
				if(valx < 0)	button |= (1<<4);	//left
				if(valy < 0)	button |= (1<<5);	//down

				if((valx != 0)||(valy != 0)||(button != button_bak)){
//				if((valx != valx_bak)||(valy != valy_bak)||(button != button_bak)){
					if(button_bak != 0){
						sio_tx('.');
				    	mouse_sendbyte(button);		//  
					    mouse_sendbyte(valx);		// left(-) / right(+)
					    mouse_sendbyte(valy);		// down(-) / up(+)
					}
					valx_bak = valx;		//backup
					valy_bak = valy;
					button_bak = button;
				}
			}
		}

		mouse_ctrl();
		cmd	= mouse_recvbyte();

		if(cmd==0)continue;	//error
//		sio_tx('.');
		sio_txhex(cmd);

		if((cmd<=0xDF)||(cmd==0xF1)||(cmd==0xFA)){
			if(err != cmd){
		    	mouse_sendbyte(0xFE);	//error
				err = cmd;
			}else{
		    	mouse_sendbyte(0xFA);	//error
			}
			continue;
		}
//	    mouse_sendbyte_wait(0xFA);	//ack
	    mouse_sendbyte(0xFA);	//ack

		if(cmd== 0xFF){	//reset
		    mouse_sendbyte(0xAA);		// CHECK
		    mouse_sendbyte(0x00);		// ID

//		}else if(cmd== 0xFE){//đM
//		}else if(cmd== 0xF6){//ftHg
		}else if(cmd== 0xF5){			//data report disable

			sample = 0;

		}else if(cmd== 0xF4){			//data report enable

			sample = 1;

		}else if(cmd== 0xF3){//sampling rate

			cmd	= mouse_recvbyte_wait();	//0x14 / 0x28
			sio_tx('-');
			sio_txhex(cmd);
		    mouse_sendbyte(0xFA);	//ack

		}else if(cmd== 0xF2){//get device ID
	
		    mouse_sendbyte(0x00);		// 

//		}else if(cmd== 0xF0){//remote mode
//		}else if(cmd== 0xee){//set rap mode
//		}else if(cmd== 0xec){//reset rap mode
		}else if(cmd== 0xeb){//get data packet
	    	mouse_sendbyte(8);		//  button
		    mouse_sendbyte(0);		// x
		    mouse_sendbyte(0);		// y
//		}else if(cmd== 0xEA){//Xg[[h
		}else if(cmd== 0xe9){//get read status
		    mouse_sendbyte(0b000000);		// 
		    mouse_sendbyte(2);		// Resolution(4mm/cnt)
		    mouse_sendbyte(100);	// report rate
		}else if(cmd== 0xe8){//set resolution
			cmd	= mouse_recvbyte_wait();	// 3=8count
			sio_tx('-');
			sio_txhex(cmd);
		    mouse_sendbyte_wait(0xFA);	//ack
//		}else if(cmd== 0xe7){//Set Scaling 2:1
//		}else if(cmd== 0xe6){//Set Scaling 1:1
		}else{
		}
	}
}

/*
*EC<FA<F9<FF<E9
*F5<FA<F2<FF<E2
*F1<FE
<E2<F2<FF
<E2<F2<FF
<E2<F9<FF
<E2<F2<FF
<E2<F2<FF
<E2<F9<FF
<F1
*F6<FA<E9
*F6<FA<E9

ECFAF1F1F6F5F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F6F5F6F5F314F1E803E6F328F4

EC
FA
F6
F5
F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1
F6
F5
F6
F5
F314
F1
E803
E6
F328
F4
*/
/*
ECFAF6F5F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F6F5F6F5F3F1E8E6F3F4
ECFAF6F5F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F1F6F5F6F5F3-14F1E8-03E6F3-28F4
*/
