//-----------------------------------------------------------------------
//  VAʐM֐  for ATtiny26   by Takuya Matsubara
//-----------------------------------------------------------------------
#include <avr/io.h>
#include "sio.h"

#define BAUDRATE 9600        //{[[g

#ifndef F_CPU
#define   F_CPU   8000000    //CPUNbNg 8MHz
#endif

#define  PRESCALE   4        //vXP[l
#define  PRESCALECR 3        //vXP[ݒl

#define    SIO_PORT PORTB      //ISPp|[g
#define    SIO_DDR  DDRB       //ISPp|[go͐ݒ
#define    SIO_TX   1          //Mrbg

#define USEMAX232 0

#define  SIO_TIFR    TIFR    //^C}tO

#define SIO_TCNT    (0x100-((F_CPU/PRESCALE)/BAUDRATE))

//-----------------------------------------------------------------------
// VA|[g
//-----------------------------------------------------------------------
void sio_init(void)
{
    SIO_DDR |=  (1<<SIO_TX);
#if USEMAX232
    SIO_PORT |= (1<<SIO_TX);
#else
    SIO_PORT &= ~(1<<SIO_TX);
#endif

    TCCR1A= 0;                // ^C}1 [h 
    TCCR1B= PRESCALECR;       // ^C}1 vXP[ݒ
}


//-----------------------------------------------------------------------
// 1bitEGCg
//-----------------------------------------------------------------------
void sio_bitwait(void)
{
    while(!(SIO_TIFR & (1 << TOV1)));
    // TOV1rbg1ɂȂ܂

    TCNT1 = SIO_TCNT;
    SIO_TIFR |= (1 << TOV1);  // TIFR̃rbgNA
}

//-----------------------------------------------------------------------
// 1oCgM
//-----------------------------------------------------------------------
int sio_tx(char sio_txdat)
{
    unsigned char mask = 0x01;

    //X^[grbg
#if USEMAX232
    SIO_PORT &= ~(1<<SIO_TX);
#else
    SIO_PORT |= (1<<SIO_TX);
#endif
    TCNT1 = SIO_TCNT;
    SIO_TIFR |= (1 << TOV1);  // TIFR̃rbgNA
    sio_bitwait();

    //f[^rbg0-7
    while(mask != 0){    
#if USEMAX232
        if(sio_txdat & mask)
            SIO_PORT |= (1<<SIO_TX);
        else
            SIO_PORT &= ~(1<<SIO_TX);
#else
        if(sio_txdat & mask)
            SIO_PORT &= ~(1<<SIO_TX);
        else
            SIO_PORT |= (1<<SIO_TX);
#endif

        mask = mask<<1;
        sio_bitwait();
    }

    //Xgbvrbg
#if USEMAX232
    SIO_PORT |= (1<<SIO_TX);
#else
    SIO_PORT &= ~(1<<SIO_TX);
#endif
    sio_bitwait();
    return(0);
}


//-----------------------------------------------------------------------
// 񑗐M
//-----------------------------------------------------------------------
void sio_txstr(char *str)
{
	char ch;

    while(*str != 0)
    {
		ch = *str++;
        sio_tx(ch);
		if(ch==13)
	        sio_tx(10);
    }
}
